/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.require("com.ibm.mm.builder.iwidget.SystemWidget");
dojo.require("com.ibm.mm.builder.iwidget.TabSpaceSelector");

dojo.declare("com.ibm.mm.builder.systemwidget.TabSpaceSelector", com.ibm.mm.builder.iwidget.SystemWidget, {
	
	windowWidth : null,
	
    onLoad: function(){
    	this.spaceSelector = new com.ibm.mm.builder.iwidget.TabSpaceSelector();
		this.getViewRootNode().appendChild(this.spaceSelector.domNode);
		this.firstLoading = true; //avoid refreshing model when first loading		
	},

	onRefresh: function(iEvent){
		if(!this.firstLoading){
			// refresh space model
			com.ibm.mm.builder.utils.spaceUtil.getSpaceModel();
		}
		this.firstLoading = false;
		if (this.spaceSelector) {
			this.spaceSelector.refresh(iEvent.payload);
			this.connection = dojo.connect(window, "onresize", this, "handleWindowResize");
		}
	},
	
	handleWindowResize: function(e){
		if (dojo.isIE){
			if (this.windowWidth){			
				if (this.windowWidth == document.body.offsetWidth){
					return;
				}
			}
			this.windowWidth = document.body.offsetWidth;
			this.spaceSelector.refresh();
		} else {
			this.spaceSelector.refresh();
		}
	},
	
	onPageSwitched: function(iEvent){
		this.onRefresh({
			payload: com.ibm.mm.builder.utils.spaceUtil.getSpaceIdByPageId(iEvent.payload)
		});
	},
	
	onUnload:function(){
		if (this.connection){
			dojo.disconnect(this.connection);
		}	
	}
});


