/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide( "com.ibm.mashups.enabler.Locator");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.Deferred");

/**
 * This interface defines search methods that allow locating resources in a model.
 * A resource is identified by its ID (mandatory). This interface is the base for all locators;
 * other locators allow a more specific search in the context they are offered in, 
 * e.g. a search for a node with certain properties in a model.<br>
 * A <code>Locator</code> is usually obtained using the <code>getLocator()</code> method .
 * <pre>
 * var treeModel model = ...;
 * var locator = model.getLocator();
 * var node = locator.find(...);
 * </pre>
 * This locator returns an {@code Object} which is part of some model.
 * What exact kind of object is returned depends on the locator.
 * Please refer to individual JavaScriptDoc for the locator used. 
 * The result object can be expected to be an element of the model
 * the locator is used on unless specified otherwise.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare( "com.ibm.mashups.enabler.Locator", null,     {
    /**
     * Returns an element of a model with the given ID.
     * @param {com.ibm.mashups.enabler.Identifiable} id identifiable or string id of the object to find; 
     * must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.Deferred} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is
     * the element with the given ID or <code>null</code> if the element cannot be found.
     */
    find: function (id) {
    }
});
