/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ModifiableMetaData");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.MetaData");

/**
 * A modifiable interface allowing to set meta data associated with a resource.
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ModifiableMetaData", com.ibm.mashups.enabler.MetaData, {
    /**
     * Sets the value for the meta data identified by the specified name.
     * @param {String} name     name of meta data to set the value for; must not be <code>null</null>
     * @param {String} value    meta data value to set; must not be <code>null</null>
     * @return {String} the former value for the name; if none existed, <code>null</code> is returned
     */
    setMetaData: function(name, value){
    },
    /**
     * Confirms whether setting the meta data is possible.
     * @param {String} name     name of meta data to set the value for; must not be <code>null</null>
     * @param {String} value    meta data value to set; must not be <code>null</null>
     * @return {Boolean} true if the value can be set, otherwise false.
     */
    confirmSetMetaData: function(name, value){
    },
    
    /**
     * Removes the meta data identified with the specified name.
     * @param{String} name  name of meta data to remove; must not be <code>null</null>
     * @return {String} the former value for the name; if none existed, <code>null</code> is returned
     */
    removeMetaData: function(name){
    },
    /**
     * Confirms whether removing the meta data is possible.
     * @param{String} name  name of meta data to remove; must not be <code>null</null>
     * @return {Boolean} true if the name can be removed, otherwise false.
     */
    confirmRemoveMetaData: function(name){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.MetaDataImpl");
dojo.require("com.ibm.mm.enabler.MetaDataImpl2");
