/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ThemeProvider");

dojo.require("com.ibm.mashups.enabler.Identifiable");

/**
 * An interface that allows the retrieval and setting of a Theme object that
 * is associated with a resource.
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.ThemeProvider", null, {
    /**
     * Returns the theme id associated with this element.
     * @type String
     * @return the theme id for this element or <code>null</code> if none was set.
     * @deprecated use com.ibm.mashups.enabler.ThemeProvider.getThemeIdentifier instead
     */
    getTheme: function(){
    },
    
    /**
     * Sets the theme id.
     * @param {String} theme theme id to set, must not be <code>null</code>.
     * @type void
     * @deprecated use com.ibm.mashups.enabler.ThemeProvider.setThemeIdentifier instead
     */
    setTheme: function(theme){
    },
    
    /**
     * Returns the theme identifier associated with this element.
     * @return {com.ibm.mashups.enabler.Identifiable} theme identifier for this element or <code>null</code> if none
     * was set.
     */
    getThemeIdentifier: function(){
    },
    
    /**
     * Sets the theme by its identifier.
     * @param {com.ibm.mashups.enabler.Identifiable} theme identifier to set, must not be <code>null</code>.
     * @type void
     */
    setThemeIdentifier: function(theme){
    }
});
