/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.SharedNavigationModel");

dojo.require("com.ibm.mashups.enabler.TreeModel");
dojo.require("com.ibm.mashups.enabler.navigation.SharedNavigationNode");
dojo.require("com.ibm.mashups.enabler.navigation.SharedNavigationRoot");
//<INTERFACE>
/**
 * Interface for a shared navigation model. This tree model contains a dedicated root
 * node, which holds navigation nodes shared to me by other users. These nodes may have
 * child nodes in case other users shared not only single navigation nodes but whole
 * navigation trees.
 * The shared navigation model is read-only. It may be used only to locate navigation nodes
 * shared by other users. Subscribing to (also referred to as accepting) such navigation
 * nodes is done with the users navigation model.<br>
 * <br>
 * The shared navigation model supports the following strategies:
 * <ul>
 * <li>{@link com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy ListLoadAheadStrategy}</li>
 * <li>{@link com.ibm.mashups.enabler.strategy.HiddenMetaDataLoadingStrategy HiddenMetaDataLoadingStrategy}</li>
 * </ul>
 *
 * @ibm-api
 * @ibm-module CoreModel
 */
dojo.declare("com.ibm.mashups.enabler.model.SharedNavigationModel", com.ibm.mashups.enabler.TreeModel, {
    /**
     * Returns the layout model for the given page.
     * @param {com.ibm.mashups.enabler.navigation.NavigationNode} node the NavigationNode or, if node is a string,
     * the uri of the node for which to return its model. The page must be part
     * of this model. Must not be <code>null</code>.
     * @return {com.ibm.mashups.enabler.model.LayoutModel} a layout model or
     * <code>null</code> if none exists.
     */
    getLayoutModel: function(node){
    },
    
    /**
     * Indicates if the shared navigation node is subscribed to, also referred to
     * accepted, or not.
     * @param {String} id of the node. Must not be <code>null</code>.
     * @type Boolean
     * @return <code>true</code> if the shared navigation node is subscribed to,
     * <code>false</code> if not.
     */
    isAccepted: function(id){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.navigation.SharedNavigationModelImpl");
