/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy");

dojo.require("com.ibm.mashups.enabler.strategy.Strategy");

/**
 * Interface that defines a load ahead strategy for loading elements of a list.
 * When applied to a list model it will load the given number of elements at a
 * time from the backend.<br>
 * Example; A ListLoadAheadStrategy with interval = 10 will cause the model to
 * load new data from the backend with every 10th call of the method next() when
 * using the iterator of the list.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.strategy.ListLoadAheadStrategy", com.ibm.mashups.enabler.strategy.Strategy, {
    /**
     * @param {int} interval number of elements to be loaded ahead from the
     * backend. must not be <code>null</code> or less than one.
     */
    constructor: function(interval){
        this.interval = interval;
    },
    
    /**
     * Returns the number of elements to load ahead
     * @type int
     * @return number of elements to load ahead
     */
    getInterval: function(){
        return this.interval;
    }
});
