/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.services.ContainerService");

//<INTERFACE>
/**
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.services.ContainerService",null,  {
    /**
     * The service name to be used to fetch the service from the ServiceManager
     * @type String
     */
    SERVICE_NAME: "iWidgetContainerService",
    
    /**
     * Constant defining the provider for event information
     * @type String
     */
    PROVIDER_EVENTS: "events",

    /**
     * Constant defining the provider for wire information
     * @type String
     */
    PROVIDER_WIRES: "wires",
    
    /**
     * Constant defining the provider for attribute information
     * @type String
     */
    PROVIDER_ATTRIBUTES: "attributes",

    registerOnChangeListener:function(provider, contextAndCallback) {
    },

    /**
     * Sets the persistence mode for the given type to the given new mode.
     *
     * @param {String} provider  One of the PROVIDER_* constants defined in this service. Must never be NULL.
     * @return {String} the current persistence mode for the given provider. May be NULL.
     */
    getPersistenceMode:function(provider, newMode) {
    },
    
    /**
     * Sets the persistence mode for all providers into their respective modifiable mode.
     *
     * @type void
     */
    switchToModifiablePersistenceMode:function() {
    }

});

// make sure we can reference this globally
com.ibm.mashups.iwidget.services.ContainerService.SERVICE_NAME = "iWidgetContainerService";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_EVENTS = "events";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_WIRES = "wires";
com.ibm.mashups.iwidget.services.ContainerService.PROVIDER_ATTRIBUTES = "attributes";

//</INTERFACE>

dojo.require("com.ibm.mm.iwidget.services.ContainerServiceImpl");
