/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.widget.EventProvider");

dojo.require("com.ibm.mashups.iwidget.IEventDescription");

/**
 * Interface defines functions to access handled or published event descriptions.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.EventProvider", null, {
    /**
     * @private
     */
    constructor: function() {
    
    },
    /**
     This method returns an array of event description. Only published event of this widget will be returned.
     @type {com.ibm.mashups.iwidget.IEventDescription}
     @returns{com.ibm.mashups.iwidget.IEventDescription[] }  array of event description
     */
    getWidgetPublishedEvents: function() {
    },
    
    /**
     This method returns an array of event description. Only handled event of this widget will be returned.
     @type {com.ibm.mashups.iwidget.IEventDescription[]}
     @returns{com.ibm.mashups.iwidget.IEventDescription[] }  array of event description
     */
    getWidgetHandledEvents: function() {
    },
    /**
     This method returns the required event.
     @param {String}name name of required public event
     @type {com.ibm.mashups.iwidget.IEventDescription}
     @returns{com.ibm.mashups.iwidget.IEventDescription }  an event description it returns NULL if event can't be found.
     */
    getPublicEvent: function(name) {
    }
    
});
