/* Copyright IBM Corp. 2012  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.livetext.ConfigEntry");

//<INTERFACE>
/**
 * This API defines the service model configuration entry
 * 
 * @ibm-api
 * @ibm-module iWidget
 */
dojo.declare("com.ibm.mashups.livetext.ConfigEntry", null, {

	/**
	 * Creates a new instance of livetext config entry.
	 *
	 * @param {String} match the CSS3 Selection expression to match a live text. Must not be <code>null</code>.
	 * @param {Boolean} processEnclosedTags should all the nested live text be processed in this request. If true, then all the live text will be processed. If false,
	 * only the out most live text of this type will be processed. May be <code>null</code>.
	 * @param {String} module the module to register the implementation livetextModel under. Must not be <code>null</code>.
	 * @param {String} path the url to load the livetextModel implementation resource file. Must not be <code>null</code>.
	 * @param {String} baseClass the JavaScript class which implement the livetextModel. Must not be <code>null</code>. 
	 * @param {Boolean} waitOnPreTag The value of true or false to determine if the service should process this entry defined tags before the process of the previous 
     *                  entry defined tags have been completed. The default value is true. <br /> Must not be <code>null</code>. 
	 * @param {String} configId a unique id to identify the entry. This is useful in case we have same baseClass as different handlers. configId will be used to find nodes are for which matching criteria.Must not be <code>null</code>. 
	 */
	constructor : function(/* String */match, /* Boolean */
			processEnclosedTags, /* String */module,
			/* String */path, /* String */baseClass ,/*Boolean*/ waitOnPreTag,/* String */id) {
	},

	/**
	 * Compare if this configuration entry is same as the given entry. 
	 *
	 * @param {com.ibm.mashups.livetext.ConfigEntry} entry The entry to be compared with this entry. Must not be <code>null</code>.
	 * @returns {Boolean} The value indicats if the two entries are the same. 
	 */
	isEqual : function(/* ConfigEntry */entry) {
	}
});
//</INTERFACE>

dojo.require("com.ibm.mm.livetext.ConfigEntryImpl");
